function HarrisCorners(img, flagCheckerBoard)

if flagCheckerBoard
    %create a checkerboard image
    I = checkerboard(40,2,2);
    
    %Find the corners in the image.
    C = detectHarrisFeatures(I);
    
    %Display the corners when the maximum number of desired corners is the default setting of 200.
    subplot(1,2,1);
    imshow(I);
    hold on
    plot(C.Location(:,1), C.Location(:,2), '*', 'Color', 'c')
    title('Corners')
    hold off 
    
    subplot(1,2,2);
    imshow(I);
    hold on
    plot(C.Location(1:3,1), C.Location(1:3,2), '*', 'Color', 'm')
    title('Maximum 3 Corners')
    hold off
end
 
%Find the corners in the image.
 
C = detectHarrisFeatures(img);
figure;
subplot(3,2,1);
imshow(img);
hold on
plot(C.Location(:,1), C.Location(:,2), '*', 'Color', 'c')
title(['Default output, N corners: ' num2str(size(C.Location,1))]);
hold off

best50Perc = round(size(C.Location,1)/2);
subplot(3,2,2);
imshow(img); hold on;
plot(C.selectStrongest(best50Perc));%,'*', 'Color', 'm')
title(['Best 50% corners: ' num2str(best50Perc)]);

subplot(3,2,3);
 %Min Quality varies in [0 , 1] and is a percentage related to the max
 %present in the image
C_QL01 = detectHarrisFeatures(img, 'MinQuality', 0.1);
imshow(img);
hold on
plot(C_QL01.Location(:,1), C_QL01.Location(:,2), '*', 'Color', 'c')
title('Quality level = 0.1')
hold off

subplot(3,2,4);
C_QL_02 = detectHarrisFeatures(img, 'MinQuality', 0.2);
imshow(img);
hold on
plot(C_QL_02.Location(:,1), C_QL_02.Location(:,2), '*', 'Color', 'c')
title('Quality level = 0.2')
hold off
 
%Gaussian filter size (default 5)
subplot(3,2,5);
C_FC_05 = detectHarrisFeatures(img, 'FilterSize', 7);
imshow(img);
hold on
plot(C_FC_05.Location(:,1), C_FC_05.Location(:,2), '*', 'Color', 'c')
title('FilterCoeff. Gauss with sigma 2')
hold off


%Gaussian filter size (default 5)
subplot(3,2,6);
C_FC_05 = detectHarrisFeatures(img, 'FilterSize', 11);
imshow(img);
hold on
plot(C_FC_05.Location(:,1), C_FC_05.Location(:,2), '*', 'Color', 'c')
title('FilterCoeff. Gauss with sigma 3.5')
 
 
